module CoinMarketCap
  module Configuration
    # Default API endpoint
    DEFAULT_API_ENDPOINT = 'https://api.coinmarketcap.com/v1'.freeze

    # Request read timeout
    attr_writer :timeout

    # Default parameters
    attr_accessor :default_params

    # Yield self to be able to configure
    # CoinMarketCap with block-style configuration.
    #
    # Example:
    #
    #   CoinMarketCap.configure do |configuration|
    #     configuration.timeout = 500
    #   end
    def configure
      yield self
    end

    # API endpoint
    def api_endpoint
      @api_endpoint ||= DEFAULT_API_ENDPOINT
    end

    # Request read timeout
    def timeout
      @timeout
    end
  end
end